"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const NativeAirMapsModule_1 = __importDefault(require("./specs/NativeAirMapsModule"));
const createFabricMap = (ViewComponent, Commands) => {
    return (0, react_1.forwardRef)((props, ref) => {
        const fabricRef = (0, react_1.useRef)(null);
        (0, react_1.useImperativeHandle)(ref, () => ({
            async getMarkersFrames(onlyVisible) {
                if (fabricRef.current) {
                    return NativeAirMapsModule_1.default.getMarkersFrames((0, react_native_1.findNodeHandle)(fabricRef.current) ?? -1, onlyVisible);
                }
                else {
                    throw new Error('getMarkersFrames is only supported on iOS with Fabric.');
                }
            },
            async getCoordinateForPoint(point) {
                if (fabricRef.current) {
                    return NativeAirMapsModule_1.default.getCoordinateForPoint((0, react_native_1.findNodeHandle)(fabricRef.current) ?? -1, point);
                }
                else {
                    throw new Error('getCoordinateForPoint is only supported on iOS with Fabric.');
                }
            },
            async getPointForCoordinate(coordinate) {
                if (fabricRef.current) {
                    return NativeAirMapsModule_1.default.getPointForCoordinate((0, react_native_1.findNodeHandle)(fabricRef.current) ?? -1, coordinate);
                }
                else {
                    throw new Error('getPointForCoordinate is only supported on iOS with Fabric.');
                }
            },
            async getAddressFromCoordinates(coordinate) {
                if (fabricRef.current) {
                    return NativeAirMapsModule_1.default.getAddressFromCoordinates((0, react_native_1.findNodeHandle)(fabricRef.current) ?? -1, coordinate);
                }
                else {
                    throw new Error('getAddressFromCoordinates is only supported on iOS with Fabric.');
                }
            },
            async takeSnapshot(config) {
                if (fabricRef.current) {
                    return NativeAirMapsModule_1.default.takeSnapshot((0, react_native_1.findNodeHandle)(fabricRef.current) ?? -1, config);
                }
                else {
                    throw new Error('takeSnapshot is only supported on iOS with Fabric.');
                }
            },
            async getCamera() {
                if (fabricRef.current) {
                    return NativeAirMapsModule_1.default.getCamera((0, react_native_1.findNodeHandle)(fabricRef.current) ?? -1);
                }
                else {
                    throw new Error('getCamera is only supported on iOS with Fabric.');
                }
            },
            async getMapBoundaries() {
                if (fabricRef.current) {
                    return NativeAirMapsModule_1.default.getMapBoundaries((0, react_native_1.findNodeHandle)(fabricRef.current) ?? -1);
                }
                else {
                    throw new Error('getMapBoundaries is only supported on iOS with Fabric.');
                }
            },
            animateToRegion(region, duration) {
                if (fabricRef.current) {
                    try {
                        Commands.animateToRegion(fabricRef.current, JSON.stringify(region), duration);
                    }
                    catch (error) {
                        throw new Error('Failed to animateToRegion');
                    }
                }
                else {
                    throw new Error('animateToRegion is only supported on iOS with Fabric.');
                }
            },
            fitToElements(edgePadding, animated) {
                if (fabricRef.current) {
                    try {
                        Commands.fitToElements(fabricRef.current, JSON.stringify(edgePadding), animated);
                    }
                    catch (error) {
                        throw new Error('Failed to fitToElements');
                    }
                }
                else {
                    throw new Error('fitToElements is only supported on iOS with Fabric.');
                }
            },
            fitToSuppliedMarkers(markers, edgePadding, animated) {
                if (fabricRef.current) {
                    try {
                        Commands.fitToSuppliedMarkers(fabricRef.current, JSON.stringify(markers), JSON.stringify(edgePadding), animated);
                    }
                    catch (error) {
                        throw new Error('Failed to fitToSuppliedMarkers');
                    }
                }
                else {
                    throw new Error('fitToSuppliedMarkers is only supported on iOS with Fabric.');
                }
            },
            animateCamera(camera, duration) {
                if (fabricRef.current) {
                    try {
                        Commands.animateCamera(fabricRef.current, JSON.stringify(camera), duration);
                    }
                    catch (error) {
                        throw new Error('Failed to animateCamera');
                    }
                }
                else {
                    throw new Error('animateCamera is only supported on iOS with Fabric.');
                }
            },
            fitToCoordinates(coordinates, edgePadding, animated) {
                if (fabricRef.current) {
                    try {
                        Commands.fitToCoordinates(fabricRef.current, JSON.stringify(coordinates), JSON.stringify(edgePadding), animated);
                    }
                    catch (error) {
                        throw new Error('Failed to fitToCoordinates');
                    }
                }
                else {
                    throw new Error('fitToCoordinates is only supported on iOS with Fabric.');
                }
            },
            setCamera(camera) {
                if (fabricRef.current) {
                    try {
                        Commands.setCamera(fabricRef.current, JSON.stringify(camera));
                    }
                    catch (error) {
                        console.error('Failed to set camera:', error);
                    }
                }
                else {
                    console.warn('setCamera is only supported on iOS with Fabric.');
                }
            },
        }));
        // @ts-ignore
        return <ViewComponent {...props} ref={fabricRef}/>;
    });
};
exports.default = createFabricMap;
